<?php

	// Convert A Simple Bitmap to an Amiga Font
		// What an imaginative title
	
$dir = opendir("./Bitmap/");
while (($fontname = readdir($dir)) !== false) { Convert($fontname);}
//fclose($dir);
die();


function Convert($fontname) {
	$FontOut="";
	if (substr(strtolower($fontname),-4)==".png") {
		$img=imagecreatefrompng("./Bitmap/".$fontname);

		$UseFontName=substr($fontname,0,-4);
		// First, create the ".font" file
		$fh=fopen("Amiga/".$UseFontName.".font","w");
		$path=$UseFontName.'/8';
		$out="";
		$out=$out.pack("cccc",15,0,0,1);
		$l=strlen($path);
		for ($m=0;$m<256;$m++) {
			if ($m<$l) {$out=$out.substr($path,$m,1);}
			if ($m>=$l) {$out=$out.pack("c",0);}
		}
		$out=$out.pack("cccc",0,8,0,2);
		fputs($fh,$out);
		fclose($fh);
		if (file_exists("Amiga/".$UseFontName)==0 ){mkdir("Amiga/".$UseFontName);}
		
		
		// Grabbed from https://andrewgraham.dev/amiga-bitmap-fonts-part-3-the-font-descriptor-file/
		//	    struct Message tf_Message;  /* reply message for font removal */
		//	    UWORD   tf_YSize;
		//	    UBYTE   tf_Style;
		//	    UBYTE   tf_Flags;
		//	    UWORD   tf_XSize;
		//	    UWORD   tf_Baseline;
		//	    UWORD   tf_BoldSmear;       /* smear to affect a bold enhancement */
		//
		//	    UWORD   tf_Accessors;
		//	    UBYTE   tf_LoChar;
		//	    UBYTE   tf_HiChar;
		//	    APTR    tf_CharData;        /* the bit character data */
		//
		//	    UWORD   tf_Modulo;          /* the row modulo for the strike font data   */
		//	    APTR    tf_CharLoc;         /* ptr to location data for the strike font  */
		//	                                /*   2 words: bit offset then size           */
		//	    APTR    tf_CharSpace;       /* ptr to words of proportional spacing data */
		//	    APTR    tf_CharKern;        /* ptr to words of kerning data              */		
	
		
		$CharData=array();
		for ($m=0;$m<8;$m++) {$CharData[$m]="";}

		$CharLoc="";
		$CharSpace="";
		$CharKern="";
		// Next, we'll form the data.
		$pw=0;
		$test="";
		for ($m=32;$m<128;$m++) {
			$pw+=8;
			$bx=($m-32)%32;
			$by=Floor(($m-32)/32);
			$cx=$bx*8;	//  Assuming the font is Black on White, on a 256x32 pixel image
			$cy=$by*8;
			if ($m>126) {$cx=0;$cy=0;}
			for ($y=0;$y<8;$y++) {
				$byte=0;
				for ($x=0;$x<8;$x++) {
					$val=0;
					$rgb=imagecolorat($img,$cx+$x,$cy+$y);
					$r = ($rgb >> 16) & 0xFF;
					if ($r<100) {$val=1;}
					$byte=$byte+($val<<(7-$x));
				}
				$CharData[$y]=$CharData[$y].pack("c",$byte);
			}
			if ($m<128) {$CharLoc=$CharLoc.pack("nn",($m-32)*8,8);} //vv
		}
		$CharLoc=$CharLoc.pack("nn",0,8); // Extra one, for good luck! I don't have a sodding clue at this point!
		echo "Compare : ".strlen($CharData[0])." vs ".($pw/8);


// Pinched the header from another font!! (Colossal)
		$Top32=pack("cccccccc",0,0,3,243,0,0,0,0);			//8
		$Top32=$Top32.pack("cccccccc",0,0,0,1,0,0,0,0);		//16
		$Top32=$Top32.pack("cccccccc",0,0,0,0,0,0,1,61);	//24
		$Top32=$Top32.pack("cccccccc",0,0,3,233,0,0,1,61);	//32

		$Next78=pack("cccccccc",112,0,78,117,0,0,0,0);		//8
		$Next78=$Next78.pack("cccccccc",0,0,0,0,12,0,0,0);		//16
		$Next78=$Next78.pack("cccccccc",0,26,15,128,0,1,0,0);	//24
		$Next78=$Next78.pack("cccccccc",0,0,0,0,0,0,0,0);		//32
		$Next78=$Next78.pack("cccccccc",0,0,0,0,0,0,0,0);		//40
		$Next78=$Next78.pack("cccccccc",0,0,0,0,0,0,0,0);		//48
		$Next78=$Next78.pack("cccccccc",0,0,0,0,0,0,0,0);		//56
		$Next78=$Next78.pack("cccccccc",0,0,0,0,0,0,0,0);		//64
		$Next78=$Next78.pack("cccccccc",0,0,12,0,0,0,0,26);		//72
		$Next78=$Next78.pack("cccccc",0,0,0,0,4,132);			//78
		
		$YSize=8;
		$Style=0;
		$Flags=2;
		$XSize=8;
		$Baseline=6;
		$BoldSmear=1;
		$Accessors=0;
		$LoChar=32;
		$HiChar=127;

		$FontOut=$Top32.$Next78.pack("cccc",0,$YSize,$Style,$Flags);	// 82
		$FontOut=$FontOut.pack("cccc",0,$XSize,0,$Baseline);			// 86
		$FontOut=$FontOut.pack("cccc",0,$BoldSmear,0,$Accessors);		// 92
		$FontOut=$FontOut.pack("cc",$LoChar,$HiChar);					// 94
		$FontOut=$FontOut.pack("cccc",0,0,0,110);						// Pointer to the start of the char data
		$FontOut=$FontOut.pack("cc",0,strlen($CharData[0]));			// "Modulo"
		$FontOut=$FontOut.pack("cccc",0,0,3,110);						// Pointer to the start of the ... pointer.. data!
		$FontOut=$FontOut.pack("cccc",0,0,0,0);							// Character Widths for Propotional fonts
		$FontOut=$FontOut.pack("cccc",0,0,0,0);							// Character Spacing for Proportional fonts

		
		for ($y=0;$y<8;$y++) {
			$FontOut=$FontOut.$CharData[$y];
		}
//		$Modulo=strlen($CharData[0]); // The gap in bytes between each line of data.
//		$FontOut=$FontOut.pack("cc",0,$Modulo);
		$FontOut=$FontOut.$CharLoc;
		
		
		$FontOut=$FontOut.pack("cccccc",0,0,0,0,3,236);
		$FontOut=$FontOut.pack("cccccccc",0,0,0,4,0,0,0,0);
		$FontOut=$FontOut.pack("cccccccc",0,0,0,14,0,0,0,68);
		$FontOut=$FontOut.pack("cccccccc",0,0,0,92,0,0,0,98);
		$FontOut=$FontOut.pack("cccccccc",0,0,0,0,0,0,3,242);

		
		$fh=fopen("Amiga/".$UseFontName.'/8',"w");
		fputs($fh,$FontOut);
		fclose($fh);
		
//		die();

	}
	

}
	

	
?>